segment code
..start:
        ; Initialization
        mov     ax, data
        mov     ds, ax
        mov     ax, stack
        mov     ss, ax
        mov     sp, stacktop
        ; Calculate Fibonacci series
        lea     esi, [series + 3]
        mov     ch, count - 2
loop:
        mov     cl, 4
        clc
        pushf
fdigit:
        mov     al, [esi]
        mov     ah, 0
        mov     bl, [esi + 4]
        popf
        adc     al, bl
        aaa
        pushf
        or      ax, 3030h
        mov     [esi + 8], al
        dec     esi
        dec     cl
        jnz     fdigit
        popf
        add     esi, 8
        dec     ch
        jnz     loop
        ; Display the series
        lea     esi, [series]
        mov     ch, count
display:
        mov     cl, 4
        lea     edi, [sfib]
ddigit:
        mov     bl, [esi]
        mov     [edi], bl
        inc     esi
        inc     edi
        dec     cl
        jnz     ddigit
        mov     dx, sfib
        mov     ah, 9
        int     0x21
        dec     ch
        jnz     display
        ; Terminate the program
exit:
        mov     ax, 0x4c00
        int     21h

segment data
count   equ     20
series  db      '0000'
        db      '0001'
        times count - 2 resb 4
sfib    resb    4
        db      13, 10, '$'

segment stack   stack
        resb    64
stacktop:
