segment code
..start:
        ; Initialization
        mov     ax, data
        mov     ds, ax
        mov     ax, stack
        mov     ss, ax
        mov     sp, stacktop
        ; Ask for name (calling the DOS write-string function)
        mov     dx, qname
        mov     ah, 9
        int     0x21
        ; Get name from keyboard buffer (calling the DOS read-string function)
        mov     dx, buffer
        mov     ah, 0x0a
        int     0x21
        ; Display "hello" message (calling the DOS write-string function)
        lea     esi, [buffer + 2]
        mov     cl, [buffer + 1]
        lea     edi, [hname]
copychar:
        mov     bl, [esi]
        mov     [edi], bl
        inc     esi
        inc     edi
        dec     cl
        test    cl, cl
        jnz     copychar
        mov     byte [edi], '!'
        mov     byte [edi + 1], 13
        mov     byte [edi + 2], 10
        mov     byte [edi + 3], '$'
        mov     dx, hello
        mov     ah, 9
        int     0x21
        ; Terminate the program (calling the DOS exit function)
        mov     ax, 0x4c00
        int     0x21

segment data
maxlen  equ     20
buffer  db      maxlen + 1
        resb    maxlen + 2
qname   db      'What is your name? ', '$'
hello   db      13, 10, 'Hello '
hname   resb    maxlen
        resb    4

segment stack   stack
        resb    64
stacktop:
