segment code
..start:
        ; Initialization
        mov     ax, data
        mov     ds, ax
        mov     ax, stack
        mov     ss, ax
        mov     sp, stacktop
                ; Display title
                mov     dx, stitle
        mov     ah, 09h
        int     21h
                ; Ask for first number
loop:
        mov     dx, snum1
        mov     ah, 09h
        int     21h
        ; Read first number
        mov     dx, num1
        mov     ah, 0ah
        int     21h
        mov     al, [num1 + 1]
        cmp     al, 0
        je      exit                             ; exit the loop if no input
        ; Ask for second number
        mov     dx, snum2
        mov     ah, 09h
        int     21h
        ; Read second number
        mov     dx, num2
        mov     ah, 0ah
        int     21h
        ; Do the addition
        lea     esi, [num1 + numlen + 1]
        lea     edi, [res + numlen]
        mov     cl, numlen
        clc
        pushf
digit:
        mov     al, [esi]                        ; first operand
        mov     ah, 0
        mov     bl, [esi + numlen + 3]           ; second operand
        popf
        adc     al, bl
        aaa
        pushf
        or      ax, 3030h
        mov     [edi], al
        dec     esi
        dec     edi
        dec     cl
        jnz     digit
        mov     [edi], ah
        popf
        ; Display result
        mov     dx, sresult
        mov     ah, 09h
        int     21h
        jmp     loop
        ; Terminate the program
exit:
        mov     ax, 0x4c00
        int     21h

segment data
numlen  equ     6
stitle  db      13, 10, 'Addition, of two 6-digit positive integers', '$'
snum1   db      13, 10, 'First number  ? ', '$'
snum2   db      13, 10, 'Second number ? ', '$'
sresult db      13, 10, 'Result = '
res     resb    numlen + 1
        db      13, 10, '$'
num1    db      numlen + 1
        resb    numlen + 2
num2    db      numlen + 1
        resb    numlen + 2

segment stack   stack
        resb    64
stacktop:
